%define daemon_user monitor
%define httpconfdir httpd/conf.d
%define daemon_group apache
%define webuser apache

%{?dgroup:%define daemon_group %{dgroup}}

Summary: pnp4nagios (PNP is not PerfParse) for op5monitor
Name: monitor-pnp
Version: %{op5version}
Release: %{op5release}%{?dist}
Group: op5/Monitor
License: GPLv2 and MIT and BSD
Prefix: /opt/monitor
URL: http://www.op5.com
BuildRoot: %{_tmppath}/%{name}-%{version}
Source0: %name-%version.tar.gz

Requires: monitor >= 4.0
Requires: op5-monitor-supported-webserver
Requires: perl-Time-HiRes
Requires: rrdtool-perl >= 1.6.0
Requires: php-mbstring
Requires: rrdtool >= 1.6.0
Requires: op5-rrdtool-config
Requires: sed >= 4.0.9
Requires: monitor-ninja
Requires: php-gd
BuildRequires: autoconf
BuildRequires: gcc
BuildRequires: op5-phpunit
BuildRequires: perl
BuildRequires: perl-Time-HiRes
BuildRequires: rrdtool-perl >= 1.6.0
BuildRequires: rrdtool >= 1.6.0
BuildRequires: monitor-ninja-devel
BuildRequires: op5-monitor-user
%if 0%{?rhel} >= 7
%{?systemd_requires}
BuildRequires: systemd
%endif
# FIXME: must add Requires of monitor version where the CGIs are patched.


%description
PNP is an addon to Nagios which analyzes performance data provided by
plugins and stores them automatically into RRD-databases.

%package test
Summary: Test requirements for Logger
Group: op5/pnp
Requires: phantomjs
Requires: php-phpunit-PHPUnit
%if 0%{?rhel} <= 6
Requires: ruby20
Requires: ruby20-devel
%else
Requires: ruby
Requires: ruby-devel
%endif

%description test
Test requirements

%prep
%setup -q

%build
php build.php
autoconf
CFLAGS="%optflags" ./configure \
	--prefix=%{prefix} \
	--sysconfdir=%{prefix}/etc/pnp \
	--datarootdir=%{prefix}/op5/pnp \
	--libexecdir=%{prefix}/op5/pnp \
	--mandir=%{_mandir} \
	--with-nagios-user=$(id -un) \
	--with-nagios-group=$(id -gn) \
	--with-perfdata-spool-dir=%{prefix}/var/spool/perfdata \
	--with-perfdata-dir=%{prefix}/op5/pnp/perfdata

# should we change PACKAGE_NAME, PACKAGE_TARNAME from "pnp"?

%__make all


%install
rm -rf %{buildroot}
mkdir --parents %{buildroot}
make DESTDIR=%{buildroot} install
mkdir --parents %{buildroot}%{prefix}/op5/pnp/modules
install -m 755 scripts/pdppd.pl %{buildroot}%{prefix}/op5/pnp/

# owned by test
mkdir --parents --mode 755 %{buildroot}/%{prefix}/op5/ninja/modules
cp --recursive testdeps %{buildroot}/%{prefix}/op5/ninja/modules/testdeps

for i in npcd.cfg process_perfdata.cfg rra.cfg
do
	test -f op5build/$i && src=op5build/$i || src=sample-config/pnp/$i-sample
	cp "$src" %{buildroot}/%{prefix}/etc/pnp/$i
done

cp op5build/background.pdf %{buildroot}/%{prefix}/etc/pnp
cp op5build/pnp_nagios.cfg %{buildroot}/%{prefix}/op5/pnp/pnp_nagios.cfg
cp op5build/pnpcommands.cfg %{buildroot}/%{prefix}/op5/pnp/pnpcommands.cfg

%if 0%{?rhel} <= 6
mkdir --parents %{buildroot}/%{_initddir}
cp scripts/rc.npcd %{buildroot}/%{_initddir}/npcd
%else
mkdir --parents %{buildroot}%{_unitdir}
cp scripts/npcd.service %{buildroot}%{_unitdir}/npcd.service
%endif

install -Dm 644 op5build/pnp_icon.png \
	%{buildroot}%{prefix}/share/images/logos/pnp_icon.png

# remove the broker module and everything else that ends up in lib
rm -rf %{buildroot}%{prefix}/lib

# now copy the module to its proper place
cp src/npcdmod.o %{buildroot}%{prefix}/op5/pnp


# remove the install.php file. we know things will work
rm -f %{buildroot}%{prefix}/op5/pnp/install.php

# FIXME: get rid of this hack when pnp is properly patched to install
#        with a silently failing chown after install instead of
#        using INSTALL_OPTS
%if 0%{?rhel} <= 6
sed -i \
	   -e 's/\(NpcdUser=\).*/\1%{daemon_user}/' \
	   -e 's/\(NpcdGroup=\).*/\1%{daemon_group}/' \
	   %{buildroot}/%{_initddir}/npcd
%endif

# FIXME: get rid of this hack too when (see above)
sed -i \
	   -e 's/^user = .*/user = %{daemon_user}/' \
	   -e 's/^group =.*/group = %{daemon_group}/' \
	   %{buildroot}%{prefix}/etc/pnp/npcd.cfg


# Don't display the xml icon. It's pretty useless after all
# We also set it to use rrdcached by default
sed -i \
	-e 's/\(.*show_xml_icon[^=]*=\).*/\1 0;/' \
	-e 's#\(^$conf..RRD_DAEMON_OPTS[^=]*\).*#\1= "unix:/opt/monitor/var/rrdtool/rrdcached/rrdcached.sock";#' \
	%{buildroot}%{prefix}/etc/pnp/config.php

# current pnp requires rewrite rules to work properly,
# so install them
mkdir --parents %{buildroot}/etc/%{httpconfdir}
%if 0%{?rhel} >= 7
cp op5build/pnp.conf-httpd.el7 %{buildroot}/etc/%{httpconfdir}/pnp.conf
%else
cp op5build/pnp.conf-httpd %{buildroot}/etc/%{httpconfdir}/pnp.conf
%endif

mkdir --parents %{buildroot}%{prefix}/op5/nacoma/hooks/save
install -m 755 op5build/nacoma_hook.py %{buildroot}%{prefix}/op5/nacoma/hooks/save/pnp_hook.py

# create the spool directory
mkdir --parents -m 775 %{buildroot}%{prefix}/var/spool/perfdata

mkdir --parents -m 775 %{buildroot}%{prefix}/op5/pnp/perfdata/.trash

install -m 755 op5build/check_nrpe.cfg %{buildroot}%{prefix}/etc/pnp/check_commands/
ln -s check_load.php %{buildroot}%{prefix}/op5/pnp/templates.dist/load.php
ln -s check_users.php %{buildroot}%{prefix}/op5/pnp/templates.dist/users.php
ln -s check_disk.php %{buildroot}%{prefix}/op5/pnp/templates.dist/root_disk.php
ln -s check_disk.php %{buildroot}%{prefix}/op5/pnp/templates.dist/usr_disk.php
ln -s check_disk.php %{buildroot}%{prefix}/op5/pnp/templates.dist/var_disk.php

ln -s check_traffic.php %{buildroot}%{prefix}/op5/pnp/templates.dist/check_snmpif_traffic.php
ln -s check_iferrors.php %{buildroot}%{prefix}/op5/pnp/templates.dist/check_snmpif_errors.php
## remove some templates we don't want
# We either create a billion symlinks for all check_http* flavours, or
# we let all of them fall back to the (very nearly) identical default
# template.
rm -f %{buildroot}%{prefix}/op5/pnp/templates.dist/check_http*


%check
make test

%files test
%attr(755,%daemon_user,%daemon_group) %{prefix}/op5/ninja/modules/testdeps

%post
find %{prefix}/etc/pnp/pages/ -maxdepth 1 -type f -name "*.cfg" -exec \
  chown %webuser:%daemon_group {} \;

%if 0%{?rhel} <= 6
# make sure npcd is started at system boot on EL6
chkconfig --add npcd
%else
%systemd_post npcd.service
%endif

if test $1 -eq 1; then
	# new install, so edit misccommands.cfg
	# Set up process-host-perfdata and process-service-perfdata commands

	if grep -q process-service-perfdata %{prefix}/etc/misccommands.cfg
	then
		sed -i /"# command 'process-service-perfdata'"/,/\}/d %{prefix}/etc/misccommands.cfg
	fi

	if grep -q process-host-perfdata %{prefix}/etc/misccommands.cfg
	then
		sed -i /"# command 'process-host-perfdata'"/,/\}/d %{prefix}/etc/misccommands.cfg
	fi

	cat %{prefix}/op5/pnp/pnpcommands.cfg >> %{prefix}/etc/misccommands.cfg
	# edit nagios.cfg:
	# make sure we have process_performance_data activated
	if grep -q process_performance_data %{prefix}/etc/nagios.cfg
	then
		sed -i 's/process_performance_data=0/process_performance_data=1/' %{prefix}/etc/nagios.cfg
	else
		echo process_performance_data=1 >> %{prefix}/etc/nagios.cfg
	fi
fi

# remove old service_perfdata_file params in nagios.cfg,
# added by an old version of the post scriptlet
sed -i '/^# service performance data .PNP.$/,/host_perfdata_file_processing_c/d' \
	%{prefix}/etc/nagios.cfg

# Add perfdata options to nagios.cfg unless it's already there
if ! grep -q '## PNP config start' %{prefix}/etc/nagios.cfg; then
	cat %{prefix}/op5/pnp/pnp_nagios.cfg >> %{prefix}/etc/nagios.cfg
fi


# make sure process_perfdata timeout is 1 second less than the
# perfdata processing interval
hpdpi=$(grep 'host_perfdata_file_processing_interval=' %{prefix}/etc/nagios.cfg | sed 's/[^0-9]\+//')
hpdpi=$(expr $hpdpi - 1)
test -z "$hpdpi" && hpdpi=15
sed -i "s/^TIMEOUT.*=.*/TIMEOUT = $hpdpi/" %{prefix}/etc/pnp/process_perfdata.cfg

%if 0%{?rhel} <= 6
service npcd start || :
service naemon restart || :
%else
systemctl start npcd || :
systemctl start naemon || :
%endif


%preun
if [ $1 -eq 0 ]; then
	%if 0%{?rhel} <= 6
	service npcd stop || :
	%else
	%systemd_preun npcd.service
	%endif
fi


%postun
%if 0%{?rhel} >= 7
%systemd_postun_with_restart npcd.service
%endif


%files
%defattr(-,root,root)
%if 0%{?rhel} <= 6
%attr(755,root,root) %{_initddir}/npcd
%else
%attr(644,root,root) %{_unitdir}/npcd.service
%endif
%{prefix}/share/images/logos/pnp_icon.png
%attr(755,root,root) %{prefix}/bin/npcd
%attr(-,%daemon_user,%daemon_group) %{prefix}/op5/pnp
%attr(775,%daemon_user,%daemon_group) %{prefix}/var/spool/perfdata
%attr(775,%daemon_user,%daemon_group) %{prefix}/var/stats
%attr(775,%daemon_user,%daemon_group) %{prefix}/op5/pnp/templates
%attr(775,%daemon_user,%daemon_group) %{prefix}/op5/pnp/templates.special
%attr(775,%daemon_user,%daemon_group) %{prefix}/op5/pnp/perfdata
%attr(775,%daemon_user,%daemon_group) %{prefix}/op5/pnp/perfdata/.trash
%attr(775,%daemon_user,%daemon_group) %{prefix}/etc/pnp/pages
%attr(-,%daemon_user,%daemon_group) %dir %{prefix}/etc/pnp
%attr(-,%daemon_user,%daemon_group) %config(noreplace) %{prefix}/etc/pnp/*.cfg
%attr(644,root,root) %config(noreplace) %{prefix}/etc/pnp/npcd.cfg
%attr(-,%daemon_user,%daemon_group) %{prefix}/etc/pnp/*.php
%attr(-,%daemon_user,%daemon_group) %{prefix}/etc/pnp/*.pdf
%attr(-,%daemon_user,%daemon_group) %{prefix}/etc/pnp/pnp4nagios_release
%attr(-,%daemon_user,%daemon_group) %dir %{prefix}/etc/pnp/check_commands
%attr(-,%daemon_user,%daemon_group) %{prefix}/etc/pnp/check_commands/check_nrpe.cfg
%attr(-,%daemon_user,%daemon_group) %dir %{prefix}/etc/pnp/config.d
%attr(775,%daemon_user,%daemon_group) %dir %{prefix}/etc/pnp/pages
/etc/%{httpconfdir}/pnp.conf
%{prefix}/op5/nacoma/hooks/save/pnp_hook.py*
%doc AUTHORS ChangeLog COPYING INSTALL README THANKS
%doc %{_mandir}/man8/npcd.8.gz
%exclude %{prefix}/etc/pnp/config.php.0.6.26
%exclude %{prefix}/op5/ninja/modules/testdeps


%clean
rm -rf %{buildroot}


%changelog
* Tue Nov 7 2017 Robin Engström <robin.engstrom@op5.com>
- Add systemd service file

* Tue Nov 9 2010 Andreas Ericsson <ae@op5.se>
- Initial specfile creation, inherited from our pnp-0.4.12.6 package
